import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;


// $ javac Command.java
// $ java Command



public class Command {

  @SuppressWarnings("unused")
  private static String output(InputStream inputStream) throws IOException {
    StringBuilder sb = new StringBuilder();
    BufferedReader br = null;
    try {
      br = new BufferedReader(new InputStreamReader(inputStream));
      String line = null;
      while ((line = br.readLine()) != null) {
        sb.append(line + System.getProperty("line.separator"));
      }
    }
    finally {
      br.close();
    }
    return sb.toString();
  }


  public static void execute(String[] names) throws InterruptedException, IOException {
    List<String> t = new ArrayList<String>();
    for (int i = 0; i < names.length; i++) {
      t.add(names[i]);
    }
    ProcessBuilder pb = new ProcessBuilder(t);
    //System.out.println("Run echo command");
    Process process = pb.start();
    @SuppressWarnings("unused")
    int errCode = process.waitFor();
    /*System.out.println("Echo command executed, any errors? " + 
                         (errCode == 0 ? "No" : "Yes"));
    System.out.println("Echo Output:\n" + 
                       output(process.getInputStream()));
    System.out.println("Working Directory = " + 
                       System.getProperty("user.dir"));*/
  }


  public static void main(String[] args) throws InterruptedException, IOException {
    String[] arguments = {"touch", "hola"};
    Command.execute(arguments);
    arguments = new String[]{"mkdir", "hola1"};
    Command.execute(arguments);
  }
}
