import org.uma.jmetal.problem.impl.AbstractIntegerPermutationProblem;
//import org.uma.jmetal.problem.PermutationProblem;
import org.uma.jmetal.solution.PermutationSolution;

import java.io.IOException;


// $ javac -cp '.:jmetal-algorithm-5.5.2-jar-with-dependencies.jar:MOEAFramework-2.12-Demo.jar' MyMultiobjectiveTSPjMetal.java
// $ java -cp '.:jmetal-algorithm-5.5.2-jar-with-dependencies.jar:MOEAFramework-2.12-Demo.jar' MyMultiobjectiveTSPjMetal



@SuppressWarnings("serial")
public class MyMultiobjectiveTSPjMetal extends AbstractIntegerPermutationProblem {
//public class MultiobjectiveTSP implements PermutationProblem<PermutationSolution<Integer>> {

  protected int     numberOfCities;
  public double[][] distanceMatrix;
  public double[][] costMatrix;

  public MyMultiobjectiveTSPjMetal(String distanceFile, String costFile) throws IOException {
    this.distanceMatrix = ReadFile.readData(distanceFile);
    this.costMatrix     = ReadFile.readData(costFile);
    this.numberOfCities = distanceMatrix.length;
    //System.out.println(numberOfCities);

    setNumberOfVariables(this.numberOfCities);
    setNumberOfObjectives(2);
    setName("MultiobjectiveTSP");
  }


  public void evaluate(PermutationSolution<Integer> solution) {
    //System.out.println(solution);
    double fitness1;
    double fitness2;

    fitness1 = 0.0;
    fitness2 = 0.0;

    int i;
    int ini = solution.getVariableValue(0);
    for (i = 0; i < (this.numberOfCities - 1); i++) {
      int x;
      int y;

      x = solution.getVariableValue(i);
      y = solution.getVariableValue(i + 1);
      //System.out.println(x + "-" + y);
      //System.out.println(y);

      fitness1 += this.distanceMatrix[x][y];
      fitness2 += this.costMatrix[x][y];
    }
    int fin = solution.getVariableValue(i);
    fitness1 += this.distanceMatrix[fin][ini];
    fitness2 += this.costMatrix[fin][ini];
    //System.out.println(solution + ": " + ini + "-" + fin);

    solution.setObjective(0, fitness1);
    solution.setObjective(1, fitness2);
    //System.out.println(solution.getObjective(0));
    //System.out.println(solution.getObjective(1));
  }


  @Override
  public int getPermutationLength() {
    return this.numberOfCities;
  }
}
