import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;


// $ unset CLASSPATH
// $ javac ReadFile.java
// $ java ReadFile



public class ReadFile {

  public static double[][] readData(String filename) {
    BufferedReader br = null;
    FileReader fr = null;
    try {
      //br = new BufferedReader(new FileReader(filename));
      fr = new FileReader(filename);
      br = new BufferedReader(fr);
      // read first line
      int i = 0;
      String sCurrentLine = br.readLine();
      String[] splitted = sCurrentLine.split(" ");
      int numCities = splitted.length;
      double[][] res = new double[numCities][numCities];
      for (int j = 0; j < splitted.length && i <= j; j++) {
        //System.out.println(splitted[j]);
        res[i][j] = Double.parseDouble(splitted[j]);
      }
      //System.out.println();
      // rest of lines
      while ((sCurrentLine = br.readLine()) != null) {
        //System.out.println(sCurrentLine);
        i = i + 1;
        splitted = sCurrentLine.split(" ");
        for (int j = 0; j < splitted.length && i <= splitted.length; j++) {
          //System.out.println(splitted[j]);
          res[i][j] = Double.parseDouble(splitted[j]);
        }
        //System.out.println();
      }
      return res;
    }
    catch (IOException e) {
      e.printStackTrace();
    }
    finally {
      try {
        if (br != null)
          br.close();
        if (fr != null)
          fr.close();
      }
      catch (IOException ex) {
        ex.printStackTrace();
      }
    }
    return new double[0][0];
  }


  public static void main(String[] args) {
    //System.out.println("Hola");
    double[][] distanceMatrix = ReadFile.readData("src/distance.txt");
    for (int i = 0; i < distanceMatrix.length; i++) {
      for (int j = 0; j < distanceMatrix[i].length; j++) {
        System.out.println(distanceMatrix[i][j]);
      }
    }
    System.out.println();
    double[][] costMatrix = ReadFile.readData("src/cost.txt");
    for (int i = 0; i < costMatrix.length; i++) {
      for (int j = 0; j < costMatrix[i].length; j++) {
        System.out.println(costMatrix[i][j]);
      }
    }
  }
}
