#!/usr/bin/env python3
# -*- coding: utf-8 -*-


# plot the results using matplotlib
import matplotlib.pyplot as plt
import numpy
import os
import subprocess




if __name__ == "__main__":
  output = subprocess.check_output("ls {}/compareFronts" \
                                   "/".format(os.getcwd()), shell=True)
  output = output.decode().split("\n")[:-1]
  #print(output)
  i = 0
  while i < len(output):
    output[i] = output[i].split("_")[0]
    i += 1
  output = list(set(output))
  print(output)
  algorithms = {}
  fig = plt.figure()
  ax = fig.add_subplot(111)
  for f in output:
    # format file: NSGA_nondominated_fitness.txt, 
    #              SPEA_nondominated_fitness.txt, ...
    algorithm = f.split("_")[0]
    if algorithm == "SMSEMOA":
      pass
    else:
      algorithms[algorithm] = []
      with open("{}/compareFronts/{}_nondominated_fitness." \
                "txt".format(os.getcwd(), algorithm), "r") as fi:
        for line in fi.readlines():
          algorithms[algorithm].append((int(line.split()[0][:-2]), \
                                        int(line.split()[1][:-2])))
  mark = [",", "o", "v", "^", "<", ">", "*", "+"]
  m = 0
  for alg in algorithms:
    #print(alg)
    nondominated_list = list(set(algorithms[alg]))
    l = sorted(nondominated_list, key=lambda x : (x[0], x[1]))
    #print(l)
    i = 0
    while i < len(l) - 1:
      ax.plot([l[i][0], l[i + 1][0]], [l[i][1], l[i + 1][1]], c="r")
      i += 1
    aux_x = []
    aux_y = []
    for p in l:
      aux_x.append(p[0])
      aux_y.append(p[1])
    #print(aux_x)
    #print(aux_y)
    ax.scatter(aux_x, aux_y, marker=mark[m], label=alg)
    m += 1
    if m == len(mark):
      m = 0
  ax.set_title("Comparación frentes")
  ax.autoscale()
  ax.legend()
  #plt.xticks(numpy.arange(0, 15000000, step=14999999))
  fig.text(0.5, 0.02, "distancia", ha="center", va="center")
  fig.text(0.02, 0.5, "coste", ha="center", va="center", rotation="vertical")
  plt.savefig("{}/compare_fronts.png".format(os.getcwd()))
  plt.show()
