clear all
clear
clc



min = 0;
max = 10;
example_points = [];
[r, c] = size(example_points);
while r < 20
  %aux = [round(min + (max - min).*rand(1, 1)), ...
  %       round(min + (max - min).*rand(1, 1))];
  aux = [round(min + (max - min).*rand(1, 1)), ...
         round(min + (max - min).*rand(1, 1)), ...
         round(min + (max - min).*rand(1, 1))];
  [r, c] = size(example_points);
  found = 0;
  for i=1:r
    if (isequal(example_points(i,:), aux) == 1)
      found = 1;
      break;
    end
  end
  if (found == 0)
    example_points = [example_points; aux];
  end
  [r, c] = size(example_points);
end
clear i aux found max min
[pp, op] = pareto(example_points, ["MAX" "MAX", "MAX"]);
if (c == 2)
  figure
  x = op(:,1);
  y = op(:,2);
  scatter(x, y, 'o', 'FaceColor', 'blue');
  x = pp(:,1);
  y = pp(:,2);
  hold on
  scatter(x, y, 'o', 'FaceColor', 'green');
  hold off
  pp = sortrows(pp, [1 2]);
  hold on
  plot(pp(:,1), pp(:,2));
  hold off
end
if (c == 3)
  figure
  x = op(:,1);
  y = op(:,2);
  z = op(:,3);
  grid on
  scatter3(x, y, z, 'o', 'FaceColor', 'blue');
  x = pp(:,1);
  y = pp(:,2);
  z = pp(:,3);
  hold on
  scatter3(x, y, z, 'o', 'FaceColor', 'green');
  hold off
  tri = delaunay(pp(:,1), pp(:,2));
  hold on
  %trimesh(tri, pp(:,1), pp(:,2), pp(:,3), 'FaceAlpha', 0.4, ...
  %        'FaceColor', [1 1 0], 'edgecolor', 'none');
  h = trisurf(tri, pp(:,1), pp(:,2), pp(:,3), 'FaceColor', [1 1 0], ...
              'edgecolor', 'black');
  hold off
end



% test1
%clear
%clc
%FitnessFunction = @simple_multiobjective;
%numberOfVariables = 1;
%[x, fval] = gamultiobj(FitnessFunction, numberOfVariables);


% test2
%clear
%clc
%FitnessFunction = @simple_multiobjective2;
%numberOfVariables = 3;
%[x, fval] = gamultiobj(FitnessFunction, numberOfVariables);
%scatter3(fval(:,1), fval(:,2), fval(:,3), 'k.');


% test3
%clear
%clc
%a = zeros(2, 1);
%b = [2; 1];
%c = [3; -.5];
%fun = @(u)simple_multiobjective3(u, a, b, c);
%[x, f, ef] = gamultiobj(fun, 2);
%grid on
%tri = delaunay(f(:,1), f(:,2));
%%trimesh(tri, f(:,1), f(:,2), f(:,3), 'FaceAlpha', 0.4, 'FaceColor', ...
%%        [1 1 0], 'edgecolor', 'none');
%F = scatteredInterpolant(f(:,1), f(:,2) ,f(:,3), 'linear', 'none');
%sgr = min(f(:,1)):.003:max(f(:,1));
%ygr = min(f(:,2)):.003:max(f(:,2));
%[XX, YY] = meshgrid(sgr, ygr);
%ZZ = F(XX, YY);
%mesh(XX, YY, ZZ);
%h = surf(XX, YY, ZZ, 'FaceColor', [1 1 0], 'edgecolor', 'none');
%%h = trisurf(tri, f(:,1), f(:,2), f(:,3), 'FaceColor', [1 1 0], ...
%%            'edgecolor', 'black');
%hold on
%scatter3(f(:,1), f(:,2), f(:,3), 'filled', 'MarkerEdgeColor', 'k');
%hold off



function [pareto_points, other_points] = pareto(points, function_domains)
  [r, c] = size(points);
  if (nargin == 1)
    function_domains = [];
    for index=1:c
      function_domains = [function_domains; "MAX"];
    end
  end
  clear index
  
  mat = zeros(r, c);
  
  for i=1:r
    for j=i+1:r
      aux = [];
      for k=1:c
        if (strcmp(function_domains(k), "MAX") == 1)
          if (points(i, k) > points(j, k))
            aux = [aux; 1];
          elseif (points(i, k) < points(j, k))
            aux = [aux; -1];
          else
            aux = [aux; 0];
          end
        else
          if (points(i, k) > points(j, k))
            aux = [aux; -1];
          elseif (points(i, k) < points(j, k))
            aux = [aux; 1];
          else
            aux = [aux; 0];
          end
        end
      end
      if (any(aux(:)==-1) == 0)
        if (any(aux(:)==1) == 1)
          aux = 1;
        else
          aux = 0;
        end
      else
        if (any(aux(:)==1) == 0)
          aux = -1;
        else
          aux = 0;
        end
      end
      mat(i, j) = aux;
    end
  end
  clear k
  
  for i=1:r
    mat(i, i) = 0;
  end
  
  for i=1:r
    for j=i:r
      mat(j, i) = -mat(i, j);
    end
  end
  
  pareto_points = [];
  for i=1:r
    if (any(mat(i,:)==-1) == 0 && any(mat(i,:)==1) == 1)
      pareto_points = [pareto_points; points(i,:)];
    end
  end
  
  other_points = [];
  [rp, cp] = size(pareto_points);
  for i=1:r
    found = 1;
    for j=1:rp
      if (isequal(points(i,:), pareto_points(j,:)) == 1)
        found = 0;
        break;
      end
    end
    if (found == 1)
      other_points = [other_points; points(i,:)];
    end
  end
end



%function f = simple_multiobjective(x)
%  f(1) = (x + 2) ^ 2 - 10;
%  f(2) = (x - 2) ^ 2 + 20;
%  f(3) = 5;
%end



%function f = simple_multiobjective2(x)
%  f(1) = sqrt(1 + norm(x) ^ 2);
%  f(2) = 0.5 * sqrt(1 + norm(x) ^ 2) + 2;
%  f(3) = 0.25 * sqrt(1 + norm(x) ^ 2) - 4;
%end



%function f = simple_multiobjective3(x, a, b, c)
  % all column vectors
%  x = x(:);
%  a = a(:);
%  b = b(:);
%  c = c(:);
  %f(1) = sqrt(1 + norm(x - a) ^ 2);
  %f(2) = 0.5 * sqrt(1 + norm(x - b) ^ 2) + 2;
  %f(3) = 0.25 * sqrt(1 + norm(x - c) ^ 2) - 4;
%  f(1) = norm(x + a);
%  f(2) = norm(x + b);
%  f(3) = norm(x + c);
%end
